using System;
using System.Security.Cryptography;
using System.IO;
using System.Text;

public class ejemploSHARSA
  {

  public static void Main(string[] args)
    {
    
    if(args.Length==0)
      {
      System.Console.WriteLine("\n  Uso: ejemploSHA512.exe fichero\n\n");
      System.Environment.Exit(0);

      }
    
    // Leemos el fichero a firmar

    StreamReader sr = new StreamReader(args[0]);
    string mensaje = sr.ReadToEnd();
    sr.Close();

    byte[] mensajeBytes = Encoding.ASCII.GetBytes(mensaje);

    // Creamos una clase SHA1
    
    SHA1 sha = SHA1.Create();

    // Realizamos el HASH del fichero en bytes
    
    byte[] hash = sha.ComputeHash(mensajeBytes);
    
    System.Console.WriteLine("Hash: "+BitConverter.ToString(hash));

    // Generamos un Provider RSA

    RSACryptoServiceProvider rsa = new RSACryptoServiceProvider();

    // Es en el firmado cuando se generan el par de llaves. Firmamos

    byte[] signbytes = rsa.SignHash(hash,"1.3.14.3.2.26");
    
    // Exportamos los parametros para usarlos en la verificacin. Parte
    // de estos parmetros son la clave pblica que enviamos al otro punto.

    RSAParameters rsaparams = rsa.ExportParameters(false);

    System.Console.WriteLine("Hash Firmado: \n\n"+BitConverter.ToString(signbytes));
    System.Console.Write("\n(Cambie el fichero para prueba) Quiere cambiar la firma? (S/N) ");

    if(String.Compare(System.Console.ReadLine(),"S")==0)
      signbytes = new byte[signbytes.Length];
    
    // Releemos el fichero por si queremos cambiar algo

    StreamReader sr2 = new StreamReader(args[0]);
    string mensaje2 = sr2.ReadToEnd();
    sr2.Close();    

    // Realizamos de nuevo el hash

    byte[] mensajeBytes2 = Encoding.ASCII.GetBytes(mensaje2);
    SHA1 sha2 = SHA1.Create();
    byte[] hash2 = sha2.ComputeHash(mensajeBytes2);
    
    System.Console.WriteLine("\nHash 2: "+BitConverter.ToString(hash2));    
    
    // Creamos un provider RSA

    RSACryptoServiceProvider rsa2 = new RSACryptoServiceProvider();

    // Importamos los parmetros que extrajimos anteriormente

    rsa.ImportParameters(rsaparams);
    

    if(rsa.VerifyHash(hash2,"1.3.14.3.2.26",signbytes))
      {
      System.Console.WriteLine("Firma Correcta!");
      }else{
      System.Console.WriteLine("Firma Incorrecta!");
      }


    }

  }
